(function ($, Drupal) {
  Drupal.behaviors.imageSizesBehavior = {
    attach: function (context, settings) {

      $('img.image-sizes', context).once('imageSizesBehaviorLoad').each(function () {
        if (!$(this).data('image-sizes')) {
          $(this).data('image-sizes', JSON.parse($(this).attr('data-src').replace(/\\/g, '')));
        }
        this.addEventListener('load', load, false);
      });

      $.map($('img.image-sizes', context),function(ele){
        var parent = $(ele).parent();
        new ResizeSensor(parent, function() {
          parent.find('> img.image-sizes').each(function(){
            if ($(this).visible(true)) {
              imageSizesSetUrl(this);
            }
          })
        });
      });

      $(window).on('scroll resize scrollstop', function(){
        init();
      });

      $(window).scroll();
    }
  };
  function load(e) {
    ele = e.srcElement;
    $(ele).attr('width', ele.naturalWidth).attr('height', ele.naturalHeight);
    $(ele).removeClass('pre-load');
  }
  function init() {
    $('img.image-sizes.pre-load').each(function(){
      if ($(this).visible(true)) {
        imageSizesSetUrl(this);
      }
    });
  }
  function imageSizesSetUrl(ele) {
    var width = $(ele).parent().width();
    var conf = $(ele).data('image-sizes');
    var newUrl = false;
    var a;
    for ( var a in conf ) {
      newUrl = conf[a];
      if (a >= width) {
        break;
      }
    }
    if (width > a) {
      ele.src = $(ele).attr('data-src-fallback');
      return;
    }
    if (newUrl !== ele.src) {
      ele.src = newUrl;
    }
  }
})(jQuery, Drupal);
